
#    Note:  This is loaded into the namespace  CvUpdate

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable modulemenu {undefined}
    foreach item $::VMEConfig::ModuleMenu {lappend modulemenu $item}

    variable indexmenu {1 2 3 4 5 6 7 8 9 10 11 12 13 14 15}
    variable ifmenu [list PCI_OPTLINK USB]
    variable fpgamenu [list USER VME]

    variable ModuleName [first $modulemenu]
    variable ModuleType [first $modulemenu]
    variable ModuleIndex [first $indexmenu]

    variable filelist {undefined}
    variable filename [first $filelist]

    variable iftype [first $ifmenu]
    variable fpga  [first $fpgamenu]
    


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
   }

     proc do_Program {w} {
          variable ModuleName
          variable ModuleIndex
          variable ModuleType
          variable filename
          variable iftype
          variable fpga

       if {$ModuleName == "undefined"} {Alert "please select module to program!"; return}

       set VMEAddress [string range [first [ReadRegisterAttributes FlashData]] 4 end]
       if {[string length $VMEAddress] != 8} {
           Alert "bad or unsafe VME base address discovered"; return}

       if {$w == 0} {

          Confirm CvUpdate "Load firmware $filename for flash memory $fpga using $iftype into $ModuleName#$ModuleIndex at address 0x$VMEAddress"

       } else {

           switch -glob $ModuleType {

                CAEN_V1720 -
                CAEN_V1740 -
                CAEN_V1742 -
                CAEN_V1724  {
                    switch $iftype {
                        PCI_OPTLINK {
                          if {[expr 0x$VMEAddress & 0x80000000] == [expr 0x80000000]} {
                              set link [expr (0x$VMEAddress >> 20) & 15]
                              set brd  [expr (0x$VMEAddress >> 16) & 15]
                              set address [string range $VMEAddress 4 end]]
                          } else {
                              set link 0
                              set brd 0
                              set address $VMEAddress
                          }
                          set cmd "[file join . CvUpdate cvUpgrade] $filename $iftype -link $link -bdnum $brd  -VMEbaseaddress $address -param [file join CvUpdate V1724 CVupgrade_params_Digitizers.txt]"
                           InsertLog "executing $cmd\\n"
                           set z [catch {eval exec $cmd} m]
                           InsertLog "Action completed with rc = $z and response \\n$m\\n\\n"
                           Alert "finished"
                        }
                        USB {
                           set cmd "[file join . CvUpdate cvUpgrade] $filename $iftype -link 0 -VMEbaseaddress $VMEAddress -param [file join CvUpdate V1724 CVupgrade_params_Digitizers.txt]"
                           InsertLog "executing $cmd\\n"
                           set z [catch {eval exec $cmd} m]
                           InsertLog "Action completed with rc = $z and response \\n$m\\n\\n"
                           Alert "finished"
                        }
                        default {Alert "request not supported"}
                    }
                }
            
                CAEN_V1495  {
                    switch $fpga {
                        USER {
                           set cmd "[file join . CvUpdate cvUpgrade] $filename $iftype -link 0 -VMEbaseaddress $VMEAddress -param [file join CvUpdate V1495 CVupgrade_params_V1495_USER.txt]"
                           InsertLog "executing $cmd\\n"
                           set z [catch {eval exec $cmd} m]
                           InsertLog "Action completed with rc = $z and response \\n$m"
                           if {$z == 0} {
                               WriteRegister UserConfig 1
                               InsertLog "User FPGA reload requested\\n"
                           }
                           Alert "finished"
                        }
                        VME {
                           set cmd "[file join . CvUpdate cvUpgrade] $filename $iftype -link 0 -VMEbaseaddress $VMEAddress -param [file join CvUpdate V1495 CVupgrade_params_V1495_VME.txt]"
                           InsertLog "executing $cmd\\n"
                           set z [catch {eval exec $cmd} m]
                           InsertLog "Action completed with rc = $z and response \\n$m"
                           Alert "finished"
                        }
                        default {Alert "request not supported"}
                    }
                }

                default {Alert "Firmware programing not supported for $ModuleType"}
           }

       }

     }
   
 
      proc do_ModuleName {w} {
        global env
        variable ModuleName
        variable ModuleType
        variable filelist
        variable filename
        set ModuleType $w
        set ModuleName [string tolower [second [split $w _]]]

        set FirmwareDir [file join $env(MIDASBASE) TclHttpd Html VME CvUpdate [second [split $w _]]]

        set z [catch {file isdirectory $FirmwareDir} m]
        if {$z != 0 || $m == 0} {
            Alert "Unable to access $FirmwareDir or $FirmwareDir is not a directory"
            return
        }

        set arg "-name \"*rbf\" -or -name \"*cfa\""
        set z [catch {eval exec find $FirmwareDir $arg} m]

        if {$z != 0} {
            Alert "Unable to obtain firmware files: $m"
            return
        }

        set filelist {}
        foreach item $m {
            if {[string length $item] == 0} {continue}
            lappend filelist $item
        }

        if {[llength $filelist] == 0} {set filename "undefined"} else {set filename [first $filelist]}

     }

     proc do_ModuleIndex {w} {
          variable ModuleIndex

          set ModuleIndex $w
     }

     proc do_FileName {w} {
          variable filename

          set filename $w
     }

     proc do_InterFace {w} {
          variable iftype

          set iftype $w
     }

     proc do_Fpga {w} {
          variable fpga

          set fpga $w
     }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                TYPE    {do_ModuleName [lindex $w 1]}
                INDEX   {do_ModuleIndex [lindex $w 1]}
                FILE    {do_FileName [lindex $w 1]}
                IF      {do_InterFace [lindex $w 1]}
                FPGA    {do_Fpga [lindex $w 1]}

                PROGRAM {do_Program 0}
                CONFIRM {do_Program 1}
      
                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }


}  ;# end of if {$started == 0}

