

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable ModuleName patterngen
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

    variable allmodules 0

    variable BCR 0
    variable polarity 0

    variable select 0
    variable start 0
    variable delay 0

    for {set i 0} {$i < 16} {incr i} {
       variable signal$i 0
       variable polarity$i 0
    }

    variable Rmsg
    variable Wmsg

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}



   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

   proc show_variables {} {
        variable ModuleIndex
        variable ModuleMenu
        variable allmodules
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg
       variable BCR
       variable polarity

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "ModuleMenu=$ModuleMenu; ModuleIndex=$ModuleIndex; "
        InsertLog "allmodules=$allmodules"
        InsertLog "Rmsg=$Rmsg"
        InsertLog "Wmsg=$Wmsg"
        UpdateModule
        InsertLog "BCR = $BCR"
        InsertLog "Polarity = $polarity"
   }

    proc do_BCR {} {
       variable delay
       variable start
       variable select
       variable BCR

       set BCR [expr ($delay << 4) + ($start << 1) + $select]

       WriteRegister BCR $BCR
    }

    proc do_Polarity {} {
       variable polarity

       set polarity 0
       for {set i 0} {$i < 16} {incr i} {
          variable polarity$i
          set polarity [expr $polarity + ([set polarity$i] << $i)]
       }

       WriteRegister Polarity $polarity
    }

    proc click-delay {vl} {variable delay; set delay $vl; do_BCR}
    proc click-smrst {}   {WriteRegister BCR 8}
    proc click-select {vl}  {variable select; set select $vl; do_BCR}
    proc click-start {vl}   {variable start; set start $vl; do_BCR}
    proc click-signal {w vl}   {variable signal$w; set signal$w $vl; WriteRegister PulseHeight$w $vl}
    proc click-polarity {w vl} {variable polarity$w; set polarity$w $vl; do_Polarity}
    proc click-pulse {vl} {WriteRegister Trigger [expr 1 << $vl]}

    proc click-initialise {} {
       for {set i 0} {$i < 16} {incr i} {
         WriteRegister SetUp$i [expr 0x800 + (1 << $i)]
       }
    }

    proc UpdateModule {} {
       variable delay
       variable start
       variable select
       variable BCR
       variable polarity

        set BCR [ReadRegister BCR]

        set select [expr $BCR & 1]
        set start [expr ($BCR >> 1) & 1]
        set delay [expr ($BCR >> 4) & 255]

        set polarity [ReadRegister Polarity]

       for {set i 0} {$i < 16} {incr i} {
          variable polarity$i
          set polarity$i [expr ($polarity >> $i) & 1]
       }
    }

    proc do_Save {which} {
        variable ModuleIndex
        variable ModuleName


        set SAV $ModuleIndex

           set ModuleIndex $which
           InsertLog "Saving Settings for [set ModuleName]#[set ModuleIndex]"

           DBSetValue BCR      [ReadRegister BCR]
           DBSetValue Trigger  [ReadRegister Trigger]
           DBSetValue Polarity [ReadRegister Polarity]

           for {set i 0} {$i < 16} {incr i} {
               DBSetValue SetUp$i       [ReadRegister SetUp$i]
               DBSetValue PulseHeight$i [ReadRegister PulseHeight$i]
           }

        set ModuleIndex $SAV
    }

    proc do_SaveAll {} {
        variable ModuleName
        variable ModuleMenu

        foreach module $ModuleMenu {do_Save $module}

        InsertLog "Settings for All [set ModuleName] modules updated in DB"

        Elog INFORMATION "Settings for All [set ModuleName] modules updated in DB"
    }

    proc do_Restore {which} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleMenu
        variable allmodules

        set SAV1 $ModuleIndex
        set SAV2 $allmodules

        set allmodules 0
        set ModuleIndex $which

        InsertLog "Restoring Settings for [set ModuleName]#[set ModuleIndex]"

           WriteRegister BCR      [DBGetValue BCR]
           WriteRegister Trigger  [DBGetValue Trigger]
           WriteRegister Polarity [DBGetValue Polarity]

           for {set i 0} {$i < 16} {incr i} {
               WriteRegister SetUp$i       [DBGetValue SetUp$i]
               WriteRegister PulseHeight$i [DBGetValue PulseHeight$i]
           }
 
        set ModuleIndex $SAV1
        set allmodules $SAV2

    }

    proc do_RestoreAll {} {
        variable ModuleName
        variable ModuleMenu

       foreach module $ModuleMenu {do_Restore $module}


        InsertLog "Settings for All PatternGen [set ModuleName] modules restored from DB"

        Elog INFORMATION "Settings for All PatternGen [set ModuleName] modules restored from DB"
    }


     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   DELAY    {click-delay [lindex $w 1]}
                   SMRST    {click-smrst}
                   SELECT   {click-select [lindex $w 1]}
                   START    {click-start [lindex $w 1]}
                   SIGNAL   {click-signal [lindex $w 1] [lindex $w 2]}
                   POLARITY {click-polarity [lindex $w 1] [lindex $w 2]}
                   PULSE    {click-pulse [lindex $w 1]}
                   INIT     {click-initialise}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
               UpdateModule
           }
       }
    }

}   ;# end of if {$started == 0}

